/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: SrvConf.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef SrvConf_H
#define SrvConf_H

#include <string>
#include <vector>
#include <libxml/tree.h>

#include "Defines.h"

namespace OpenSOAP {

  class SrvConf {

    static const std::string SERVER_CONF_FILE; // = "server.conf";

  public:
    OPENSOAP_VAR
    SrvConf();
    OPENSOAP_VAR
    virtual ~SrvConf();

    OPENSOAP_VAR
    std::string getLogPath();
    OPENSOAP_VAR
    std::string getSoapMessageSpoolPath();
    OPENSOAP_VAR
    std::string getAsyncTablePath();
    OPENSOAP_VAR
    std::string getPIDPath();
    OPENSOAP_VAR
    std::string getSocketPath();
    OPENSOAP_VAR
    std::string getSecKeyPath();
    OPENSOAP_VAR
    std::string getSSMLPath();
    OPENSOAP_VAR
    std::string getBackwardProtocol();
    OPENSOAP_VAR
    std::vector<std::string> getBackwardHostnames();
    OPENSOAP_VAR
    std::string getBackwardPort();
    OPENSOAP_VAR
    std::string getBackwardCgiLocation();
    OPENSOAP_VAR
    std::string getForwarderProtocol();
    OPENSOAP_VAR
    std::string getForwarderHostname();
    OPENSOAP_VAR
    std::string getForwarderPort();
    OPENSOAP_VAR
    std::string getForwarderCgiLocation();
    OPENSOAP_VAR
    int getForwarderTimeout();
    OPENSOAP_VAR
    std::string getAddSignature();
    OPENSOAP_VAR
    bool isAddSignatureTrue();

    OPENSOAP_VAR
    int query(const std::string& queryStr, std::vector<std::string>& values);

    //private:
  protected:
    //ǂݍݑΏXMLt@C
    std::string xmlFilePath_;

    //DOMf[^
    xmlDocPtr confDocPtr_;

    //XMLt@C̓ǂݍ
    OPENSOAP_VAR
    bool loadXml();
  };

} // end of namespace OpenSOAP


#endif /* SrvConf_H */
