/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: Timeout.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef Timeout_H
#define Timeout_H

#if defined(WIN32)
#include <windows.h>
#else
#include <pthread.h>
#endif

namespace OpenSOAP {

  class Timeout {
  public:
    Timeout(int timeout_second);
#if defined(WIN32)
	Timeout(int timeout_second, HANDLE thr_id);
#else
    Timeout(int timeout_second, pthread_t thr_id);
#endif
    ~Timeout();

  public:
#if defined(WIN32)
	void setTargetThread(HANDLE thr_t);
#else
    void setTargetThread(pthread_t thr_t);
#endif
    void setTimeout(int timeout_second);

    //^C}[ĎJn(ΏۏJnO ďo)
    int start();

    //^C}[ĎI(ΏۏI ďo)
    int finish();

    // ^[QbgXbhLZĂ邩H
    bool targetThreadIsCanceled();
    
    //private:
  protected:
    bool isRunning_;    
    bool targetThreadIsCanceled_;
    int timeoutSecond_;
#if defined(WIN32)
	HANDLE targetThread_;
	HANDLE timerThr_id_;
	HANDLE isRunning_mutex_;
	static int mtCount_;
#else
    pthread_t targetThread_;
    pthread_t timerThr_id_;
    pthread_mutex_t isRunning_mutex_;
#endif

    void initMutex();
    void destroyMutex();
	static
#if defined(WIN32)
	void
#else
	void*
#endif
    	runTimeout(void* arg);
  };
}

#endif /* Timeout_H */
